// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marker_msgs:msg/FiducialDetection.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_HPP_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'fiducial'
#include "marker_msgs/msg/detail/fiducial__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marker_msgs__msg__FiducialDetection __attribute__((deprecated))
#else
# define DEPRECATED__marker_msgs__msg__FiducialDetection __declspec(deprecated)
#endif

namespace marker_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FiducialDetection_
{
  using Type = FiducialDetection_<ContainerAllocator>;

  explicit FiducialDetection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 9>::iterator, double>(this->camera_k.begin(), this->camera_k.end(), 0.0);
      this->type = "";
    }
  }

  explicit FiducialDetection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    camera_k(_alloc),
    type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 9>::iterator, double>(this->camera_k.begin(), this->camera_k.end(), 0.0);
      this->type = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _camera_d_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _camera_d_type camera_d;
  using _camera_k_type =
    std::array<double, 9>;
  _camera_k_type camera_k;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _type_type type;
  using _fiducial_type =
    std::vector<marker_msgs::msg::Fiducial_<ContainerAllocator>, typename ContainerAllocator::template rebind<marker_msgs::msg::Fiducial_<ContainerAllocator>>::other>;
  _fiducial_type fiducial;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__camera_d(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->camera_d = _arg;
    return *this;
  }
  Type & set__camera_k(
    const std::array<double, 9> & _arg)
  {
    this->camera_k = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__fiducial(
    const std::vector<marker_msgs::msg::Fiducial_<ContainerAllocator>, typename ContainerAllocator::template rebind<marker_msgs::msg::Fiducial_<ContainerAllocator>>::other> & _arg)
  {
    this->fiducial = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marker_msgs::msg::FiducialDetection_<ContainerAllocator> *;
  using ConstRawPtr =
    const marker_msgs::msg::FiducialDetection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::FiducialDetection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::FiducialDetection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marker_msgs__msg__FiducialDetection
    std::shared_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marker_msgs__msg__FiducialDetection
    std::shared_ptr<marker_msgs::msg::FiducialDetection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FiducialDetection_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->camera_d != other.camera_d) {
      return false;
    }
    if (this->camera_k != other.camera_k) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->fiducial != other.fiducial) {
      return false;
    }
    return true;
  }
  bool operator!=(const FiducialDetection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FiducialDetection_

// alias to use template instance with default allocator
using FiducialDetection =
  marker_msgs::msg::FiducialDetection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marker_msgs

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL_DETECTION__STRUCT_HPP_
