// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marker_msgs:msg/Marker.idl
// generated code does not contain a copyright notice
#include "marker_msgs/msg/detail/marker__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ids`
// Member `ids_confidence`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
marker_msgs__msg__Marker__init(marker_msgs__msg__Marker * msg)
{
  if (!msg) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->ids, 0)) {
    marker_msgs__msg__Marker__fini(msg);
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__init(&msg->ids_confidence, 0)) {
    marker_msgs__msg__Marker__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    marker_msgs__msg__Marker__fini(msg);
    return false;
  }
  return true;
}

void
marker_msgs__msg__Marker__fini(marker_msgs__msg__Marker * msg)
{
  if (!msg) {
    return;
  }
  // ids
  rosidl_runtime_c__int32__Sequence__fini(&msg->ids);
  // ids_confidence
  rosidl_runtime_c__double__Sequence__fini(&msg->ids_confidence);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
}

bool
marker_msgs__msg__Marker__are_equal(const marker_msgs__msg__Marker * lhs, const marker_msgs__msg__Marker * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->ids), &(rhs->ids)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->ids_confidence), &(rhs->ids_confidence)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  return true;
}

bool
marker_msgs__msg__Marker__copy(
  const marker_msgs__msg__Marker * input,
  marker_msgs__msg__Marker * output)
{
  if (!input || !output) {
    return false;
  }
  // ids
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->ids), &(output->ids)))
  {
    return false;
  }
  // ids_confidence
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->ids_confidence), &(output->ids_confidence)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  return true;
}

marker_msgs__msg__Marker *
marker_msgs__msg__Marker__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Marker * msg = (marker_msgs__msg__Marker *)allocator.allocate(sizeof(marker_msgs__msg__Marker), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marker_msgs__msg__Marker));
  bool success = marker_msgs__msg__Marker__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marker_msgs__msg__Marker__destroy(marker_msgs__msg__Marker * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marker_msgs__msg__Marker__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marker_msgs__msg__Marker__Sequence__init(marker_msgs__msg__Marker__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Marker * data = NULL;

  if (size) {
    data = (marker_msgs__msg__Marker *)allocator.zero_allocate(size, sizeof(marker_msgs__msg__Marker), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marker_msgs__msg__Marker__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marker_msgs__msg__Marker__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marker_msgs__msg__Marker__Sequence__fini(marker_msgs__msg__Marker__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marker_msgs__msg__Marker__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marker_msgs__msg__Marker__Sequence *
marker_msgs__msg__Marker__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__Marker__Sequence * array = (marker_msgs__msg__Marker__Sequence *)allocator.allocate(sizeof(marker_msgs__msg__Marker__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marker_msgs__msg__Marker__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marker_msgs__msg__Marker__Sequence__destroy(marker_msgs__msg__Marker__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marker_msgs__msg__Marker__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marker_msgs__msg__Marker__Sequence__are_equal(const marker_msgs__msg__Marker__Sequence * lhs, const marker_msgs__msg__Marker__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marker_msgs__msg__Marker__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marker_msgs__msg__Marker__Sequence__copy(
  const marker_msgs__msg__Marker__Sequence * input,
  marker_msgs__msg__Marker__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marker_msgs__msg__Marker);
    marker_msgs__msg__Marker * data =
      (marker_msgs__msg__Marker *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marker_msgs__msg__Marker__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marker_msgs__msg__Marker__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marker_msgs__msg__Marker__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
