// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marker_msgs:msg/MarkerStamped.idl
// generated code does not contain a copyright notice
#include "marker_msgs/msg/detail/marker_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `marker`
#include "marker_msgs/msg/detail/marker__functions.h"

bool
marker_msgs__msg__MarkerStamped__init(marker_msgs__msg__MarkerStamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marker_msgs__msg__MarkerStamped__fini(msg);
    return false;
  }
  // marker
  if (!marker_msgs__msg__Marker__init(&msg->marker)) {
    marker_msgs__msg__MarkerStamped__fini(msg);
    return false;
  }
  return true;
}

void
marker_msgs__msg__MarkerStamped__fini(marker_msgs__msg__MarkerStamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // marker
  marker_msgs__msg__Marker__fini(&msg->marker);
}

bool
marker_msgs__msg__MarkerStamped__are_equal(const marker_msgs__msg__MarkerStamped * lhs, const marker_msgs__msg__MarkerStamped * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // marker
  if (!marker_msgs__msg__Marker__are_equal(
      &(lhs->marker), &(rhs->marker)))
  {
    return false;
  }
  return true;
}

bool
marker_msgs__msg__MarkerStamped__copy(
  const marker_msgs__msg__MarkerStamped * input,
  marker_msgs__msg__MarkerStamped * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // marker
  if (!marker_msgs__msg__Marker__copy(
      &(input->marker), &(output->marker)))
  {
    return false;
  }
  return true;
}

marker_msgs__msg__MarkerStamped *
marker_msgs__msg__MarkerStamped__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerStamped * msg = (marker_msgs__msg__MarkerStamped *)allocator.allocate(sizeof(marker_msgs__msg__MarkerStamped), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marker_msgs__msg__MarkerStamped));
  bool success = marker_msgs__msg__MarkerStamped__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marker_msgs__msg__MarkerStamped__destroy(marker_msgs__msg__MarkerStamped * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marker_msgs__msg__MarkerStamped__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marker_msgs__msg__MarkerStamped__Sequence__init(marker_msgs__msg__MarkerStamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerStamped * data = NULL;

  if (size) {
    data = (marker_msgs__msg__MarkerStamped *)allocator.zero_allocate(size, sizeof(marker_msgs__msg__MarkerStamped), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marker_msgs__msg__MarkerStamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marker_msgs__msg__MarkerStamped__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marker_msgs__msg__MarkerStamped__Sequence__fini(marker_msgs__msg__MarkerStamped__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marker_msgs__msg__MarkerStamped__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marker_msgs__msg__MarkerStamped__Sequence *
marker_msgs__msg__MarkerStamped__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerStamped__Sequence * array = (marker_msgs__msg__MarkerStamped__Sequence *)allocator.allocate(sizeof(marker_msgs__msg__MarkerStamped__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marker_msgs__msg__MarkerStamped__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marker_msgs__msg__MarkerStamped__Sequence__destroy(marker_msgs__msg__MarkerStamped__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marker_msgs__msg__MarkerStamped__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marker_msgs__msg__MarkerStamped__Sequence__are_equal(const marker_msgs__msg__MarkerStamped__Sequence * lhs, const marker_msgs__msg__MarkerStamped__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marker_msgs__msg__MarkerStamped__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marker_msgs__msg__MarkerStamped__Sequence__copy(
  const marker_msgs__msg__MarkerStamped__Sequence * input,
  marker_msgs__msg__MarkerStamped__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marker_msgs__msg__MarkerStamped);
    marker_msgs__msg__MarkerStamped * data =
      (marker_msgs__msg__MarkerStamped *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marker_msgs__msg__MarkerStamped__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marker_msgs__msg__MarkerStamped__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marker_msgs__msg__MarkerStamped__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
