// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marker_msgs:msg/MarkerWithCovariance.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_HPP_
#define MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'marker'
#include "marker_msgs/msg/detail/marker__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marker_msgs__msg__MarkerWithCovariance __attribute__((deprecated))
#else
# define DEPRECATED__marker_msgs__msg__MarkerWithCovariance __declspec(deprecated)
#endif

namespace marker_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MarkerWithCovariance_
{
  using Type = MarkerWithCovariance_<ContainerAllocator>;

  explicit MarkerWithCovariance_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : marker(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 36>::iterator, double>(this->covariance.begin(), this->covariance.end(), 0.0);
    }
  }

  explicit MarkerWithCovariance_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : marker(_alloc, _init),
    covariance(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 36>::iterator, double>(this->covariance.begin(), this->covariance.end(), 0.0);
    }
  }

  // field types and members
  using _marker_type =
    marker_msgs::msg::Marker_<ContainerAllocator>;
  _marker_type marker;
  using _covariance_type =
    std::array<double, 36>;
  _covariance_type covariance;

  // setters for named parameter idiom
  Type & set__marker(
    const marker_msgs::msg::Marker_<ContainerAllocator> & _arg)
  {
    this->marker = _arg;
    return *this;
  }
  Type & set__covariance(
    const std::array<double, 36> & _arg)
  {
    this->covariance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> *;
  using ConstRawPtr =
    const marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marker_msgs__msg__MarkerWithCovariance
    std::shared_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marker_msgs__msg__MarkerWithCovariance
    std::shared_ptr<marker_msgs::msg::MarkerWithCovariance_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MarkerWithCovariance_ & other) const
  {
    if (this->marker != other.marker) {
      return false;
    }
    if (this->covariance != other.covariance) {
      return false;
    }
    return true;
  }
  bool operator!=(const MarkerWithCovariance_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MarkerWithCovariance_

// alias to use template instance with default allocator
using MarkerWithCovariance =
  marker_msgs::msg::MarkerWithCovariance_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marker_msgs

#endif  // MARKER_MSGS__MSG__DETAIL__MARKER_WITH_COVARIANCE__STRUCT_HPP_
