// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marker_msgs:msg/Fiducial.idl
// generated code does not contain a copyright notice

#ifndef MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_HPP_
#define MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'object_points'
// Member 'image_points'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marker_msgs__msg__Fiducial __attribute__((deprecated))
#else
# define DEPRECATED__marker_msgs__msg__Fiducial __declspec(deprecated)
#endif

namespace marker_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Fiducial_
{
  using Type = Fiducial_<ContainerAllocator>;

  explicit Fiducial_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit Fiducial_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _ids_type =
    std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other>;
  _ids_type ids;
  using _ids_confidence_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _ids_confidence_type ids_confidence;
  using _object_points_type =
    std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename ContainerAllocator::template rebind<geometry_msgs::msg::Point_<ContainerAllocator>>::other>;
  _object_points_type object_points;
  using _image_points_type =
    std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename ContainerAllocator::template rebind<geometry_msgs::msg::Point_<ContainerAllocator>>::other>;
  _image_points_type image_points;

  // setters for named parameter idiom
  Type & set__ids(
    const std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other> & _arg)
  {
    this->ids = _arg;
    return *this;
  }
  Type & set__ids_confidence(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->ids_confidence = _arg;
    return *this;
  }
  Type & set__object_points(
    const std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename ContainerAllocator::template rebind<geometry_msgs::msg::Point_<ContainerAllocator>>::other> & _arg)
  {
    this->object_points = _arg;
    return *this;
  }
  Type & set__image_points(
    const std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename ContainerAllocator::template rebind<geometry_msgs::msg::Point_<ContainerAllocator>>::other> & _arg)
  {
    this->image_points = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marker_msgs::msg::Fiducial_<ContainerAllocator> *;
  using ConstRawPtr =
    const marker_msgs::msg::Fiducial_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::Fiducial_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marker_msgs::msg::Fiducial_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marker_msgs__msg__Fiducial
    std::shared_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marker_msgs__msg__Fiducial
    std::shared_ptr<marker_msgs::msg::Fiducial_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Fiducial_ & other) const
  {
    if (this->ids != other.ids) {
      return false;
    }
    if (this->ids_confidence != other.ids_confidence) {
      return false;
    }
    if (this->object_points != other.object_points) {
      return false;
    }
    if (this->image_points != other.image_points) {
      return false;
    }
    return true;
  }
  bool operator!=(const Fiducial_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Fiducial_

// alias to use template instance with default allocator
using Fiducial =
  marker_msgs::msg::Fiducial_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marker_msgs

#endif  // MARKER_MSGS__MSG__DETAIL__FIDUCIAL__STRUCT_HPP_
