// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marker_msgs:msg/MarkerDetection.idl
// generated code does not contain a copyright notice
#include "marker_msgs/msg/detail/marker_detection__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `view_direction`
#include "geometry_msgs/msg/detail/quaternion__functions.h"
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `markers`
#include "marker_msgs/msg/detail/marker__functions.h"

bool
marker_msgs__msg__MarkerDetection__init(marker_msgs__msg__MarkerDetection * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marker_msgs__msg__MarkerDetection__fini(msg);
    return false;
  }
  // distance_min
  // distance_max
  // distance_max_id
  // view_direction
  if (!geometry_msgs__msg__Quaternion__init(&msg->view_direction)) {
    marker_msgs__msg__MarkerDetection__fini(msg);
    return false;
  }
  // fov_horizontal
  // fov_vertical
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    marker_msgs__msg__MarkerDetection__fini(msg);
    return false;
  }
  // markers
  if (!marker_msgs__msg__Marker__Sequence__init(&msg->markers, 0)) {
    marker_msgs__msg__MarkerDetection__fini(msg);
    return false;
  }
  return true;
}

void
marker_msgs__msg__MarkerDetection__fini(marker_msgs__msg__MarkerDetection * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // distance_min
  // distance_max
  // distance_max_id
  // view_direction
  geometry_msgs__msg__Quaternion__fini(&msg->view_direction);
  // fov_horizontal
  // fov_vertical
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // markers
  marker_msgs__msg__Marker__Sequence__fini(&msg->markers);
}

bool
marker_msgs__msg__MarkerDetection__are_equal(const marker_msgs__msg__MarkerDetection * lhs, const marker_msgs__msg__MarkerDetection * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // distance_min
  if (lhs->distance_min != rhs->distance_min) {
    return false;
  }
  // distance_max
  if (lhs->distance_max != rhs->distance_max) {
    return false;
  }
  // distance_max_id
  if (lhs->distance_max_id != rhs->distance_max_id) {
    return false;
  }
  // view_direction
  if (!geometry_msgs__msg__Quaternion__are_equal(
      &(lhs->view_direction), &(rhs->view_direction)))
  {
    return false;
  }
  // fov_horizontal
  if (lhs->fov_horizontal != rhs->fov_horizontal) {
    return false;
  }
  // fov_vertical
  if (lhs->fov_vertical != rhs->fov_vertical) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // markers
  if (!marker_msgs__msg__Marker__Sequence__are_equal(
      &(lhs->markers), &(rhs->markers)))
  {
    return false;
  }
  return true;
}

bool
marker_msgs__msg__MarkerDetection__copy(
  const marker_msgs__msg__MarkerDetection * input,
  marker_msgs__msg__MarkerDetection * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // distance_min
  output->distance_min = input->distance_min;
  // distance_max
  output->distance_max = input->distance_max;
  // distance_max_id
  output->distance_max_id = input->distance_max_id;
  // view_direction
  if (!geometry_msgs__msg__Quaternion__copy(
      &(input->view_direction), &(output->view_direction)))
  {
    return false;
  }
  // fov_horizontal
  output->fov_horizontal = input->fov_horizontal;
  // fov_vertical
  output->fov_vertical = input->fov_vertical;
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // markers
  if (!marker_msgs__msg__Marker__Sequence__copy(
      &(input->markers), &(output->markers)))
  {
    return false;
  }
  return true;
}

marker_msgs__msg__MarkerDetection *
marker_msgs__msg__MarkerDetection__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerDetection * msg = (marker_msgs__msg__MarkerDetection *)allocator.allocate(sizeof(marker_msgs__msg__MarkerDetection), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marker_msgs__msg__MarkerDetection));
  bool success = marker_msgs__msg__MarkerDetection__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
marker_msgs__msg__MarkerDetection__destroy(marker_msgs__msg__MarkerDetection * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    marker_msgs__msg__MarkerDetection__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
marker_msgs__msg__MarkerDetection__Sequence__init(marker_msgs__msg__MarkerDetection__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerDetection * data = NULL;

  if (size) {
    data = (marker_msgs__msg__MarkerDetection *)allocator.zero_allocate(size, sizeof(marker_msgs__msg__MarkerDetection), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marker_msgs__msg__MarkerDetection__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marker_msgs__msg__MarkerDetection__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marker_msgs__msg__MarkerDetection__Sequence__fini(marker_msgs__msg__MarkerDetection__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marker_msgs__msg__MarkerDetection__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marker_msgs__msg__MarkerDetection__Sequence *
marker_msgs__msg__MarkerDetection__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  marker_msgs__msg__MarkerDetection__Sequence * array = (marker_msgs__msg__MarkerDetection__Sequence *)allocator.allocate(sizeof(marker_msgs__msg__MarkerDetection__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = marker_msgs__msg__MarkerDetection__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
marker_msgs__msg__MarkerDetection__Sequence__destroy(marker_msgs__msg__MarkerDetection__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    marker_msgs__msg__MarkerDetection__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
marker_msgs__msg__MarkerDetection__Sequence__are_equal(const marker_msgs__msg__MarkerDetection__Sequence * lhs, const marker_msgs__msg__MarkerDetection__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marker_msgs__msg__MarkerDetection__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marker_msgs__msg__MarkerDetection__Sequence__copy(
  const marker_msgs__msg__MarkerDetection__Sequence * input,
  marker_msgs__msg__MarkerDetection__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marker_msgs__msg__MarkerDetection);
    marker_msgs__msg__MarkerDetection * data =
      (marker_msgs__msg__MarkerDetection *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marker_msgs__msg__MarkerDetection__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marker_msgs__msg__MarkerDetection__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marker_msgs__msg__MarkerDetection__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
